/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_FractionalFlowReserve;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_FractionalFlowReserve;


/**
 * This class represents FractionalFlowReserve - CID3621
 */
public class FractionalFlowReserve_CID3621 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new FractionalFlowReserve_CID3621 Template 
	 */
	public FractionalFlowReserve_CID3621()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumFractionalFlowReserve Object of EnumCM_FractionalFlowReserve represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_FractionalFlowReserve enumFractionalFlowReserve)
	{
		switch(enumFractionalFlowReserve)
		{
		case FRACTIONAL_FLOW_RESERVE:
			this.strCodeValue = EnumCV_FractionalFlowReserve.FRACTIONAL_FLOW_RESERVE_R_00307.getValue();
			break;
		case FRACTIONAL_FLOW_RESERVE_USING_INTRACORONARY_BOLUS:
			this.strCodeValue = EnumCV_FractionalFlowReserve.FRACTIONAL_FLOW_RESERVE_USING_INTRACORONARY_BOLUS_R_00308.getValue();
			break;
		case FRACTIONAL_FLOW_RESERVE_USING_INTRAVENOUS_INFUSION:
			this.strCodeValue = EnumCV_FractionalFlowReserve.FRACTIONAL_FLOW_RESERVE_USING_INTRAVENOUS_INFUSION_R_00309.getValue();
			break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumFractionalFlowReserve Object of EnumCM_FractionalFlowReserve represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_FractionalFlowReserve enumFractionalFlowReserve)
	{
		switch(enumFractionalFlowReserve)
		{
		case FRACTIONAL_FLOW_RESERVE : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.FRACTIONAL_FLOW_RESERVE.getSNOMEDCTID(); break;
		case FRACTIONAL_FLOW_RESERVE_USING_INTRACORONARY_BOLUS : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.FRACTIONAL_FLOW_RESERVE_USING_INTRACORONARY_BOLUS.getSNOMEDCTID(); break;
		case FRACTIONAL_FLOW_RESERVE_USING_INTRAVENOUS_INFUSION : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.FRACTIONAL_FLOW_RESERVE_USING_INTRAVENOUS_INFUSION.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for FractionalFlowReserve
	 * @param enumFractionalFlowReserve Object of EnumCM_FractionalFlowReserve.
	 */
	public void setFractionalFlowReserve(EnumCM_FractionalFlowReserve enumFractionalFlowReserve)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumFractionalFlowReserve.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumFractionalFlowReserve);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumFractionalFlowReserve);
	}
}
